<template>
  <div>
    <ob-table
      :columns="tableColumns"
      :functionalPanel="false"
      :remote-opt="{
        method: getResources
      }"
      :tableLayoutFixed="false"
      :isSmartPagination="false"
      data-qa="LogisticDomainsAgentResourcesTable"
      ref="obTableAgentResources"
      @select="onSelectItem"
    >
      <template v-slot:number="{ data }">
        <div class="number">
          <span class="letter">{{parseNumber(data.item.number).grzNum}}</span>
          <span class="code">{{parseNumber(data.item.number).grzReg}}</span>
        </div>
      </template>

      <template v-slot:risk="{ data }">
        <i :class="['icon', $options.riskColorsMap[data.item.riskGroupColor]]"></i>
      </template>

      <template v-slot:registeredAt="{ data }">
        <div class="registration-date">
          {{ new Date(data.item.registeredAt).toLocaleDateString('ru-RU') }}
        </div>
        <div class="registration-time">
          {{ new Date(data.item.registeredAt).toLocaleTimeString('ru-RU', $options.timeOptions) }}
        </div>
      </template>
    </ob-table>
  </div>
</template>

<script>
  import api from '@/api';
  import { parseNumber } from '@/helpers/order'
  import obTable from 'common-components/src/obComponents/obTable';

  export default {
    name: 'agentResourcesComponent',

    riskColorsMap: {
      'GREEN': 'risk-1-blue',
      'BLUE': 'risk-2-green',
      'YELLOW': 'risk-3-yellow',
      'ORANGE': 'risk-4-orange',
      'RED': 'risk-5-red',
      'BLACK': 'risk-6-black'
    },

    timeOptions: {
      hour: 'numeric',
      minute: '2-digit'
    },

    components: {
      obTable
    },

    props: {
      transportType: {
        type: String,
        required: true
      }
    },

    data() {
      return {
        resource: ''
      }
    },

    computed: {
      tableColumns() {
        return [
          {
            title: 'Регистрационный номер',
            key: 'number',
            slotName: 'number'
          },
          {
            title: 'группа риска',
            key: 'riskGroupColor',
            slotName: 'risk'
          },
          {
            title: 'Марка',
            key: 'mark'
          },
          {
            title: 'Цвет',
            key: 'colorTitle'
          },
          {
            title: 'год выпуска',
            key: 'issueYear'
          },
          {
            title: 'Право владения',
            key: 'holdTypeTitle'
          },
          {
            title: 'регистрация',
            key: 'registeredAt',
            slotName: 'registeredAt'
          }
        ]
      }
    },

    watch: {
      transportType: {
        handler() {
          this.$nextTick(() => {
            this.$refs.obTableAgentResources.loadData();
          })
        },
        immediate: true
      }
    },

    methods: {
      parseNumber,
      async getResources({page, size}) {
        const res = await api.linkBrowser.getAgentResource({
          type: this.transportType,
          uuid: this.$route.params.id,
          page,
          size
        });
        const fixedTransportType = this.transportType.replace(/([-_]\w)/g, g => g[1].toUpperCase());
        const data = res.content[fixedTransportType].map(item => {
          //TODO когда бэк научится присылать все поля, можно заменить ручной перебор на это чудесное выражение
          // const res = Object.keys(item).reduce((acc, i) => {
          //   return {
          //     ...acc, [i]: item[i] || '-'
          //   }
          // }, {});

          return {
            assessedBySecurityAt: item.assessedBySecurityAt || '-',
            assessedBySystemAt: item.assessedBySystemAt || '-',
            carrierRoleCode: item.carrierRoleCode || '-',
            carrierRoleTitle: item.carrierRoleTitle || '-',
            carrierTitle: item.carrierTitle || '-',
            carrierUuid: item.carrierUuid || '-',
            colorTitle: item.colorTitle || '-',
            colorUuid: item.colorUuid || '-',
            holdTypeTitle: item.holdTypeTitle || '-',
            holdTypeUuid: item.holdTypeUuid || '-',
            isActive: item.isActive || '-',
            issueYear: item.issueYear || '-',
            mark: item.mark || '-',
            number: item.number || '-',
            registeredAt: item.registeredAt || '-',
            riskGroupColor: item.riskGroupColor || '-',
            riskGroupNumber: item.riskGroupNumber || '-',
            riskGroupUuid: item.riskGroupUuid || '',
            uuid: item.uuid || '-',
            verificationStartedAt: item.verificationStartedAt || '-'
          }
        })

        return {
          content: data,
          page: res.page,
          size: res.size,
          total_elements: res.total_elements,
          total_pages: res.total_pages
        }
      },

      onSelectItem(item) {
        this.$router.push({
          path: '/sb_resource/' + item.uuid
        });
      }
    }
  }
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

  .number {
    padding: 0 6px;
    display: flex;
    align-items: stretch;
    border: 1px solid #18B4FF;
    border-radius: 2px;
    @include font-mixin(12px, 1, 400, $style-black, 0.2px, uppercase);
  }

  ::v-deep {
    .letter {
      padding: 3px 12px 3px 0;
      display: flex;
      align-items: flex-end;
    }

    .digits {
      @include font-mixin(14px, 1, 400, $style-black, 0.2px, uppercase);
      padding: 3px 0.3em;
    }

    .last-letters {
      padding: 3px 12px 3px 0;
      display: flex;
      align-items: flex-end;
    }

    .code {
      padding: 3px 0 3px 6px;
      display: flex;
      align-items: flex-end;
      border-left: 1px solid #18B4FF;
    }

    .registration-time {
      color: $color-grey-span;
    }
  }

</style>